package SliMP3::Discovery;

# $Id: Discovery.pm,v 1.12 2002/10/12 19:50:24 blackketter Exp $

# SliMP3 Server Copyright (C) 2001 Sean Adams, Slim Devices Inc.
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License, 
# version 2.

use strict;

use IO::Socket;
use SliMP3::Misc;

# Respond to a hello received from a client
#        
sub gotHello {
	my($client, $deviceid, $revision) = @_;

	if (!(($deviceid == 0x01) && ($revision >= 0x13))) {
		$::d_protocol && msg($client->id . " detected pre-V1.3 client sending wrong id/rev: $deviceid, $revision. Fixing.\n");
		$deviceid= 0x01;
		$revision= 0x12;
	}

	if ($deviceid == 0x01) { $deviceid = 'slimp3' };
	
	$client->deviceid($deviceid);

	$client->revision(int($revision / 16) + ($revision % 16)/10.0);
	
	$::d_protocol && msg($client->id . " Client says hello, deviceid = $deviceid, revision = $revision\n");
}

# Say hello to a client
#
sub sayHello {
	my $udpsock = shift;
	my $addr = shift;
	my ($ip, $port) = split( /:/, $addr);

	$::d_protocol && msg($ip . " Saying hello to: $ip, $port\n");
	
	$ip = inet_aton($ip);
	my $paddr = sockaddr_in($port, $ip);
	
	$udpsock->send( 'h'.(pack('C', 0) x 17), 0, $paddr);
}

#
# send the discovery response
#
sub sendDiscoveryResponse {
	my $client = shift;

	my $response = 'D'. (pack('C', 0) x 17);

	SliMP3::Protocol::sendClient($client, $response);
}

#
# We received a discovery request
#
sub gotDiscoveryRequest {
	my $client = shift;

	$::d_protocol && msg($client->id . " Got discovery request\n");
	&sendDiscoveryResponse($client);
}

1;
